Index: /trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative.asm
===================================================================
--- /trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative.asm	(revision 50158)
+++ /trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative.asm	(revision 50159)
@@ -3995,14 +4162,14 @@
     and AL, strict byte 0c0h                  ; 24 c0
     cmp AL, strict byte 0c0h                  ; 3c c0
-    je short 03161h                           ; 74 0e
+    je short 032b3h                           ; 74 0e
     push 00255h                               ; 68 55 02
     push 00288h                               ; 68 88 02
     push strict byte 00007h                   ; 6a 07
-    call 0190dh                               ; e8 af e7
+    call 01922h                               ; e8 72 e6
     add sp, strict byte 00006h                ; 83 c4 06
     xor si, si                                ; 31 f6
-    jmp short 0316ah                          ; eb 05
+    jmp short 032bch                          ; eb 05
     cmp si, strict byte 00007h                ; 83 fe 07
-    jnl short 03182h                          ; 7d 18
+    jnl short 032d4h                          ; 7d 18
     mov dx, 003f5h                            ; ba f5 03
     in AL, DX                                 ; ec
@@ -4013,38 +4180,63 @@
     lea dx, [si+042h]                         ; 8d 54 42
     mov ax, strict word 00040h                ; b8 40 00
-    call 0160eh                               ; e8 8f e4
+    call 0160eh                               ; e8 3d e3
     inc si                                    ; 46
-    jmp short 03165h                          ; eb e3
+    jmp short 032b7h                          ; eb e3
     test byte [bp-016h], 0c0h                 ; f6 46 ea c0
-    je short 03199h                           ; 74 11
+    je near 031cah                            ; 0f 84 ee fe
+    test byte [bp-015h], 002h                 ; f6 46 eb 02
+    je short 032eeh                           ; 74 0c
+    mov word [bp+016h], 00300h                ; c7 46 16 00 03
+    or byte [bp+01ch], 001h                   ; 80 4e 1c 01
+    jmp near 02fc1h                           ; e9 d3 fc
+    mov word [bp+016h], 00100h                ; c7 46 16 00 01
+    jmp short 032e7h                          ; eb f2
+    movzx dx, byte [bp-006h]                  ; 0f b6 56 fa
+    movzx ax, byte [bp-00eh]                  ; 0f b6 46 f2
+    call 02bbfh                               ; e8 bf f8
+    and byte [bp+01ch], 0feh                  ; 80 66 1c fe
+    mov byte [bp+017h], 000h                  ; c6 46 17 00
+    jmp near 02fc1h                           ; e9 b6 fc
+    mov al, byte [bp+016h]                    ; 8a 46 16
+    mov byte [bp-00ch], al                    ; 88 46 f4
+    mov dx, word [bp+014h]                    ; 8b 56 14
+    shr dx, 008h                              ; c1 ea 08
+    mov byte [bp-006h], dl                    ; 88 56 fa
+    mov ax, word [bp+012h]                    ; 8b 46 12
+    shr ax, 008h                              ; c1 e8 08
+    mov byte [bp-008h], al                    ; 88 46 f8
+    mov bl, byte [bp+00eh]                    ; 8a 5e 0e
+    mov byte [bp-00eh], bl                    ; 88 5e f2
+    cmp bl, 001h                              ; 80 fb 01
+    jnbe short 03342h                         ; 77 14
+    cmp AL, strict byte 001h                  ; 3c 01
+    jnbe short 03342h                         ; 77 10
+    cmp dl, 04fh                              ; 80 fa 4f
+    jnbe short 03342h                         ; 77 0b
+    mov al, byte [bp-00ch]                    ; 8a 46 f4
+    test al, al                               ; 84 c0
+    je short 03342h                           ; 74 04
+    cmp AL, strict byte 012h                  ; 3c 12
+    jbe short 03357h                          ; 76 15
     mov ax, word [bp+016h]                    ; 8b 46 16
     xor ah, ah                                ; 30 e4
-    or ah, 020h                               ; 80 cc 20
+    or ah, 001h                               ; 80 cc 01
     mov word [bp+016h], ax                    ; 89 46 16
-    mov ax, strict word 00020h                ; b8 20 00
-    jmp near 030a3h                           ; e9 0a ff
-    movzx ax, byte [bp-00ch]                  ; 0f b6 46 f4
-    sal ax, 009h                              ; c1 e0 09
-    cwd                                       ; 99
-    db  02bh, 0c2h
-    ; sub ax, dx                                ; 2b c2
-    sar ax, 1                                 ; d1 f8
-    mov cx, ax                                ; 89 c1
-    mov si, word [bp+010h]                    ; 8b 76 10
-    mov dx, word [bp+006h]                    ; 8b 56 06
-    mov di, si                                ; 89 f7
-    mov es, dx                                ; 8e c2
-    push DS                                   ; 1e
-    mov ds, dx                                ; 8e da
-    rep movsw                                 ; f3 a5
-    pop DS                                    ; 1f
-    movzx dx, byte [bp-008h]                  ; 0f b6 56 f8
+    mov ax, strict word 00001h                ; b8 01 00
+    call 02ba7h                               ; e8 54 f8
+    or byte [bp+01ch], 001h                   ; 80 4e 1c 01
     movzx ax, byte [bp-00eh]                  ; 0f b6 46 f2
-    call 02baah                               ; e8 e8 f9
-    mov byte [bp+017h], 000h                  ; c6 46 17 00
-    and byte [bp+01ch], 0feh                  ; 80 66 1c fe
-    jmp near 02faeh                           ; e9 e1 fd
-    cmp ch, 003h                              ; 80 fd 03
-    jne near 032e2h                           ; 0f 85 0e 01
+    call 02ebah                               ; e8 5c fb
+    test ax, ax                               ; 85 c0
+    je near 02f8fh                            ; 0f 84 2b fc
+    movzx dx, byte [bp-00eh]                  ; 0f b6 56 f2
+    mov ax, dx                                ; 89 d0
+    call 02cffh                               ; e8 92 f9
+    test ax, ax                               ; 85 c0
+    jne short 0337ch                          ; 75 0b
+    mov ax, dx                                ; 89 d0
+    call 02dcah                               ; e8 54 fa
+    test ax, ax                               ; 85 c0
+    je near 03068h                            ; 0f 84 ec fc
     mov cx, word [bp+006h]                    ; 8b 4e 06
     shr cx, 00ch                              ; c1 e9 0c
@@ -4055,14 +4247,14 @@
     add bx, dx                                ; 01 d3
     cmp bx, dx                                ; 39 d3
-    jnc short 031edh                          ; 73 02
+    jnc short 03395h                          ; 73 02
     db  0feh, 0c4h
     ; inc ah                                    ; fe c4
     movzx cx, byte [bp-00ch]                  ; 0f b6 4e f4
-    sal cx, 009h                              ; c1 e1 09
+    sal cx, 002h                              ; c1 e1 02
     dec cx                                    ; 49
     mov dx, bx                                ; 89 da
     add dx, cx                                ; 01 ca
     cmp dx, bx                                ; 39 da
-    jc near 03095h                            ; 0f 82 96 fe
+    jc near 030a8h                            ; 0f 82 01 fd
     mov AL, strict byte 006h                  ; b0 06
     mov dx, strict word 0000ah                ; ba 0a 00
@@ -4096,35 +4288,33 @@
     out DX, AL                                ; ee
     movzx ax, byte [bp-00eh]                  ; 0f b6 46 f2
-    call 02c69h                               ; e8 27 fa
-    mov AL, strict byte 0c5h                  ; b0 c5
+    call 02c7eh                               ; e8 94 f8
+    mov AL, strict byte 00fh                  ; b0 0f
     mov dx, 003f5h                            ; ba f5 03
     out DX, AL                                ; ee
-    movzx dx, byte [bp-006h]                  ; 0f b6 56 fa
-    sal dx, 002h                              ; c1 e2 02
-    movzx ax, byte [bp-00eh]                  ; 0f b6 46 f2
-    or ax, dx                                 ; 09 d0
-    mov dx, 003f5h                            ; ba f5 03
-    out DX, AL                                ; ee
-    mov al, byte [bp-008h]                    ; 8a 46 f8
+    movzx ax, byte [bp-008h]                  ; 0f b6 46 f8
+    sal ax, 002h                              ; c1 e0 02
+    movzx bx, byte [bp-00eh]                  ; 0f b6 5e f2
+    or bx, ax                                 ; 09 c3
+    mov al, bl                                ; 88 d8
     out DX, AL                                ; ee
     mov al, byte [bp-006h]                    ; 8a 46 fa
     out DX, AL                                ; ee
-    mov al, byte [bp-00ah]                    ; 8a 46 f6
+    mov AL, strict byte 04dh                  ; b0 4d
+    out DX, AL                                ; ee
+    mov al, bl                                ; 88 d8
     out DX, AL                                ; ee
     mov AL, strict byte 002h                  ; b0 02
     out DX, AL                                ; ee
-    movzx dx, byte [bp-00ah]                  ; 0f b6 56 f6
-    movzx ax, byte [bp-00ch]                  ; 0f b6 46 f4
-    add ax, dx                                ; 01 d0
-    dec ax                                    ; 48
-    mov dx, 003f5h                            ; ba f5 03
+    mov al, byte [bp-00ch]                    ; 8a 46 f4
     out DX, AL                                ; ee
     xor al, al                                ; 30 c0
     out DX, AL                                ; ee
-    mov AL, strict byte 0ffh                  ; b0 ff
-    out DX, AL                                ; ee
-    call 02bf8h                               ; e8 78 f9
+    mov AL, strict byte 0f6h                  ; b0 f6
+    out DX, AL                                ; ee
+    call 02c0dh                               ; e8 f3 f7
     test al, al                               ; 84 c0
-    je near 03133h                            ; 0f 84 ad fe
+    jne short 03424h                          ; 75 06
+    call 02c53h                               ; e8 32 f8
+    jmp near 02f8fh                           ; e9 6b fb
     mov dx, 003f4h                            ; ba f4 03
     in AL, DX                                 ; ec
@@ -4133,14 +4323,14 @@
     and AL, strict byte 0c0h                  ; 24 c0
     cmp AL, strict byte 0c0h                  ; 3c c0
-    je short 032a0h                           ; 74 0e
+    je short 0343eh                           ; 74 0e
     push 00255h                               ; 68 55 02
     push 00288h                               ; 68 88 02
     push strict byte 00007h                   ; 6a 07
-    call 0190dh                               ; e8 70 e6
+    call 01922h                               ; e8 e7 e4
     add sp, strict byte 00006h                ; 83 c4 06
     xor si, si                                ; 31 f6
-    jmp short 032a9h                          ; eb 05
+    jmp short 03447h                          ; eb 05
     cmp si, strict byte 00007h                ; 83 fe 07
-    jnl short 032c1h                          ; 7d 18
+    jnl short 0345fh                          ; 7d 18
     mov dx, 003f5h                            ; ba f5 03
     in AL, DX                                 ; ec
@@ -4151,181 +4341,27 @@
     lea dx, [si+042h]                         ; 8d 54 42
     mov ax, strict word 00040h                ; b8 40 00
-    call 0160eh                               ; e8 50 e3
+    call 0160eh                               ; e8 b2 e1
     inc si                                    ; 46
-    jmp short 032a4h                          ; eb e3
+    jmp short 03442h                          ; eb e3
     test byte [bp-016h], 0c0h                 ; f6 46 ea c0
-    je near 031b7h                            ; 0f 84 ee fe
+    je short 0347bh                           ; 74 16
     test byte [bp-015h], 002h                 ; f6 46 eb 02
-    je short 032dbh                           ; 74 0c
-    mov word [bp+016h], 00300h                ; c7 46 16 00 03
-    or byte [bp+01ch], 001h                   ; 80 4e 1c 01
-    jmp near 02faeh                           ; e9 d3 fc
-    mov word [bp+016h], 00100h                ; c7 46 16 00 01
-    jmp short 032d4h                          ; eb f2
-    movzx dx, byte [bp-008h]                  ; 0f b6 56 f8
-    movzx ax, byte [bp-00eh]                  ; 0f b6 46 f2
-    call 02baah                               ; e8 bd f8
-    and byte [bp+01ch], 0feh                  ; 80 66 1c fe
-    mov byte [bp+017h], 000h                  ; c6 46 17 00
-    jmp near 02faeh                           ; e9 b6 fc
-    mov al, byte [bp+016h]                    ; 8a 46 16
-    mov byte [bp-00ch], al                    ; 88 46 f4
-    mov dx, word [bp+014h]                    ; 8b 56 14
-    shr dx, 008h                              ; c1 ea 08
-    mov ax, word [bp+012h]                    ; 8b 46 12
-    shr ax, 008h                              ; c1 e8 08
-    mov byte [bp-006h], al                    ; 88 46 fa
-    mov bl, byte [bp+00eh]                    ; 8a 5e 0e
-    mov byte [bp-00eh], bl                    ; 88 5e f2
-    cmp bl, 001h                              ; 80 fb 01
-    jnbe short 0332ch                         ; 77 14
-    cmp AL, strict byte 001h                  ; 3c 01
-    jnbe short 0332ch                         ; 77 10
-    cmp dl, 04fh                              ; 80 fa 4f
-    jnbe short 0332ch                         ; 77 0b
-    mov al, byte [bp-00ch]                    ; 8a 46 f4
-    test al, al                               ; 84 c0
-    je short 0332ch                           ; 74 04
-    cmp AL, strict byte 012h                  ; 3c 12
-    jbe short 03341h                          ; 76 15
-    mov ax, word [bp+016h]                    ; 8b 46 16
-    xor ah, ah                                ; 30 e4
-    or ah, 001h                               ; 80 cc 01
-    mov word [bp+016h], ax                    ; 89 46 16
-    mov ax, strict word 00001h                ; b8 01 00
-    call 02b92h                               ; e8 55 f8
-    or byte [bp+01ch], 001h                   ; 80 4e 1c 01
-    movzx ax, byte [bp-00eh]                  ; 0f b6 46 f2
-    call 02ea5h                               ; e8 5d fb
-    test ax, ax                               ; 85 c0
-    je near 02f7ch                            ; 0f 84 2e fc
-    movzx dx, byte [bp-00eh]                  ; 0f b6 56 f2
-    mov ax, dx                                ; 89 d0
-    call 02ceah                               ; e8 93 f9
-    test ax, ax                               ; 85 c0
-    jne short 03366h                          ; 75 0b
-    mov ax, dx                                ; 89 d0
-    call 02db5h                               ; e8 55 fa
-    test ax, ax                               ; 85 c0
-    je near 03055h                            ; 0f 84 ef fc
-    mov dx, word [bp+006h]                    ; 8b 56 06
-    shr dx, 00ch                              ; c1 ea 0c
-    mov ah, dl                                ; 88 d4
-    mov cx, word [bp+006h]                    ; 8b 4e 06
-    sal cx, 004h                              ; c1 e1 04
-    mov bx, word [bp+010h]                    ; 8b 5e 10
-    add bx, cx                                ; 01 cb
-    cmp bx, cx                                ; 39 cb
-    jnc short 0337fh                          ; 73 02
-    db  0feh, 0c4h
-    ; inc ah                                    ; fe c4
-    movzx cx, byte [bp-00ch]                  ; 0f b6 4e f4
-    sal cx, 002h                              ; c1 e1 02
-    dec cx                                    ; 49
-    mov dx, bx                                ; 89 da
-    add dx, cx                                ; 01 ca
-    cmp dx, bx                                ; 39 da
-    jc near 03095h                            ; 0f 82 04 fd
-    mov AL, strict byte 006h                  ; b0 06
-    mov dx, strict word 0000ah                ; ba 0a 00
-    out DX, AL                                ; ee
-    xor al, al                                ; 30 c0
-    mov dx, strict word 0000ch                ; ba 0c 00
-    out DX, AL                                ; ee
-    mov al, bl                                ; 88 d8
-    mov dx, strict word 00004h                ; ba 04 00
-    out DX, AL                                ; ee
-    shr bx, 008h                              ; c1 eb 08
-    mov al, bl                                ; 88 d8
-    out DX, AL                                ; ee
-    xor al, bl                                ; 30 d8
-    mov dx, strict word 0000ch                ; ba 0c 00
-    out DX, AL                                ; ee
-    mov al, cl                                ; 88 c8
-    mov dx, strict word 00005h                ; ba 05 00
-    out DX, AL                                ; ee
-    shr cx, 008h                              ; c1 e9 08
-    mov al, cl                                ; 88 c8
-    out DX, AL                                ; ee
-    mov AL, strict byte 04ah                  ; b0 4a
-    mov dx, strict word 0000bh                ; ba 0b 00
-    out DX, AL                                ; ee
-    mov al, ah                                ; 88 e0
-    mov dx, 00081h                            ; ba 81 00
-    out DX, AL                                ; ee
-    mov AL, strict byte 002h                  ; b0 02
-    mov dx, strict word 0000ah                ; ba 0a 00
-    out DX, AL                                ; ee
-    movzx ax, byte [bp-00eh]                  ; 0f b6 46 f2
-    call 02c69h                               ; e8 95 f8
-    mov AL, strict byte 04dh                  ; b0 4d
-    mov dx, 003f5h                            ; ba f5 03
-    out DX, AL                                ; ee
-    movzx dx, byte [bp-006h]                  ; 0f b6 56 fa
-    sal dx, 002h                              ; c1 e2 02
-    movzx ax, byte [bp-00eh]                  ; 0f b6 46 f2
-    or ax, dx                                 ; 09 d0
-    mov dx, 003f5h                            ; ba f5 03
-    out DX, AL                                ; ee
-    mov AL, strict byte 002h                  ; b0 02
-    out DX, AL                                ; ee
-    mov al, byte [bp-00ch]                    ; 8a 46 f4
-    out DX, AL                                ; ee
-    xor al, al                                ; 30 c0
-    out DX, AL                                ; ee
-    mov AL, strict byte 0f6h                  ; b0 f6
-    out DX, AL                                ; ee
-    call 02bf8h                               ; e8 fd f7
-    test al, al                               ; 84 c0
-    jne short 03405h                          ; 75 06
-    call 02c3eh                               ; e8 3c f8
-    jmp near 02f7ch                           ; e9 77 fb
-    mov dx, 003f4h                            ; ba f4 03
-    in AL, DX                                 ; ec
-    db  02ah, 0e4h
-    ; sub ah, ah                                ; 2a e4
-    and AL, strict byte 0c0h                  ; 24 c0
-    cmp AL, strict byte 0c0h                  ; 3c c0
-    je short 0341fh                           ; 74 0e
-    push 00255h                               ; 68 55 02
-    push 00288h                               ; 68 88 02
-    push strict byte 00007h                   ; 6a 07
-    call 0190dh                               ; e8 f1 e4
-    add sp, strict byte 00006h                ; 83 c4 06
-    xor si, si                                ; 31 f6
-    jmp short 03428h                          ; eb 05
-    cmp si, strict byte 00007h                ; 83 fe 07
-    jnl short 03440h                          ; 7d 18
-    mov dx, 003f5h                            ; ba f5 03
-    in AL, DX                                 ; ec
-    db  02ah, 0e4h
-    ; sub ah, ah                                ; 2a e4
-    mov byte [bp+si-016h], al                 ; 88 42 ea
-    movzx bx, al                              ; 0f b6 d8
-    lea dx, [si+042h]                         ; 8d 54 42
-    mov ax, strict word 00040h                ; b8 40 00
-    call 0160eh                               ; e8 d1 e1
-    inc si                                    ; 46
-    jmp short 03423h                          ; eb e3
-    test byte [bp-016h], 0c0h                 ; f6 46 ea c0
-    je short 0345ch                           ; 74 16
-    test byte [bp-015h], 002h                 ; f6 46 eb 02
-    jne near 032cfh                           ; 0f 85 81 fe
+    jne near 032e2h                           ; 0f 85 75 fe
     push 00255h                               ; 68 55 02
     push 0029ch                               ; 68 9c 02
     push strict byte 00007h                   ; 6a 07
-    call 0190dh                               ; e8 b4 e4
+    call 01922h                               ; e8 aa e4
     add sp, strict byte 00006h                ; 83 c4 06
     xor al, al                                ; 30 c0
     mov byte [bp+017h], al                    ; 88 46 17
     xor ah, ah                                ; 30 e4
-    call 02b92h                               ; e8 2c f7
+    call 02ba7h                               ; e8 22 f7
     movzx ax, byte [bp-00eh]                  ; 0f b6 46 f2
     xor dx, dx                                ; 31 d2
-    call 02baah                               ; e8 3b f7
-    jmp near 031c6h                           ; e9 54 fd
+    call 02bbfh                               ; e8 31 f7
+    jmp near 031d9h                           ; e9 48 fd
     mov byte [bp-00eh], ah                    ; 88 66 f2
     cmp ah, 001h                              ; 80 fc 01
-    jbe short 0349ah                          ; 76 20
+    jbe short 034b9h                          ; 76 20
     xor ax, ax                                ; 31 c0
     mov word [bp+016h], ax                    ; 89 46 16
@@ -4338,20 +4374,20 @@
     mov word [bp+012h], ax                    ; 89 46 12
     mov word [bp+01ch], dx                    ; 89 56 1c
-    jmp near 02faeh                           ; e9 14 fb
+    jmp near 02fc1h                           ; e9 08 fb
     mov ax, strict word 00010h                ; b8 10 00
-    call 0165ch                               ; e8 bc e1
+    call 0165ch                               ; e8 9d e1
     mov dl, al                                ; 88 c2
     xor cl, cl                                ; 30 c9
     test AL, strict byte 0f0h                 ; a8 f0
-    je short 034aah                           ; 74 02
+    je short 034c9h                           ; 74 02
     mov CL, strict byte 001h                  ; b1 01
     test dl, 00fh                             ; f6 c2 0f
-    je short 034b1h                           ; 74 02
+    je short 034d0h                           ; 74 02
     db  0feh, 0c1h
     ; inc cl                                    ; fe c1
     cmp byte [bp-00eh], 000h                  ; 80 7e f2 00
-    jne short 034bch                          ; 75 05
+    jne short 034dbh                          ; 75 05
     shr dl, 004h                              ; c0 ea 04
-    jmp short 034bfh                          ; eb 03
+    jmp short 034deh                          ; eb 03
     and dl, 00fh                              ; 80 e2 0f
     mov byte [bp+011h], 000h                  ; c6 46 11 00
@@ -4369,59 +4405,59 @@
     mov word [bp+012h], ax                    ; 89 46 12
     cmp dl, 003h                              ; 80 fa 03
-    jc short 034ffh                           ; 72 15
-    jbe short 03526h                          ; 76 3a
+    jc short 0351eh                           ; 72 15
+    jbe short 03545h                          ; 76 3a
     cmp dl, 005h                              ; 80 fa 05
-    jc short 0352dh                           ; 72 3c
-    jbe short 03534h                          ; 76 41
+    jc short 0354ch                           ; 72 3c
+    jbe short 03553h                          ; 76 41
     cmp dl, 00fh                              ; 80 fa 0f
-    je short 03542h                           ; 74 4a
+    je short 03561h                           ; 74 4a
     cmp dl, 00eh                              ; 80 fa 0e
-    je short 0353bh                           ; 74 3e
-    jmp short 03549h                          ; eb 4a
+    je short 0355ah                           ; 74 3e
+    jmp short 03568h                          ; eb 4a
     cmp dl, 002h                              ; 80 fa 02
-    je short 0351fh                           ; 74 1b
+    je short 0353eh                           ; 74 1b
     cmp dl, 001h                              ; 80 fa 01
-    je short 03518h                           ; 74 0f
+    je short 03537h                           ; 74 0f
     test dl, dl                               ; 84 d2
-    jne short 03549h                          ; 75 3c
+    jne short 03568h                          ; 75 3c
     mov word [bp+014h], strict word 00000h    ; c7 46 14 00 00
     mov byte [bp+013h], 000h                  ; c6 46 13 00
-    jmp short 03557h                          ; eb 3f
+    jmp short 03576h                          ; eb 3f
     mov word [bp+014h], 02709h                ; c7 46 14 09 27
-    jmp short 03557h                          ; eb 38
+    jmp short 03576h                          ; eb 38
     mov word [bp+014h], 04f0fh                ; c7 46 14 0f 4f
-    jmp short 03557h                          ; eb 31
+    jmp short 03576h                          ; eb 31
     mov word [bp+014h], 04f09h                ; c7 46 14 09 4f
-    jmp short 03557h                          ; eb 2a
+    jmp short 03576h                          ; eb 2a
     mov word [bp+014h], 04f12h                ; c7 46 14 12 4f
-    jmp short 03557h                          ; eb 23
+    jmp short 03576h                          ; eb 23
     mov word [bp+014h], 04f24h                ; c7 46 14 24 4f
-    jmp short 03557h                          ; eb 1c
+    jmp short 03576h                          ; eb 1c
     mov word [bp+014h], 0fe3fh                ; c7 46 14 3f fe
-    jmp short 03557h                          ; eb 15
+    jmp short 03576h                          ; eb 15
     mov word [bp+014h], 0feffh                ; c7 46 14 ff fe
-    jmp short 03557h                          ; eb 0e
+    jmp short 03576h                          ; eb 0e
     push 00255h                               ; 68 55 02
     push 002adh                               ; 68 ad 02
     push strict byte 00007h                   ; 6a 07
-    call 0190dh                               ; e8 b9 e3
+    call 01922h                               ; e8 af e3
     add sp, strict byte 00006h                ; 83 c4 06
     mov word [bp+006h], 0f000h                ; c7 46 06 00 f0
     movzx ax, dl                              ; 0f b6 c2
-    call 035f3h                               ; e8 91 00
+    call 03612h                               ; e8 91 00
     mov word [bp+008h], ax                    ; 89 46 08
-    jmp near 031c6h                           ; e9 5e fc
+    jmp near 031d9h                           ; e9 52 fc
     mov byte [bp-00eh], ah                    ; 88 66 f2
     cmp ah, 001h                              ; 80 fc 01
-    jbe short 03576h                          ; 76 06
+    jbe short 03595h                          ; 76 06
     mov word [bp+016h], si                    ; 89 76 16
-    jmp near 03494h                           ; e9 1e ff
+    jmp near 034b3h                           ; e9 1e ff
     mov ax, strict word 00010h                ; b8 10 00
-    call 0165ch                               ; e8 e0 e0
+    call 0165ch                               ; e8 c1 e0
     cmp byte [bp-00eh], 000h                  ; 80 7e f2 00
-    jne short 03589h                          ; 75 07
+    jne short 035a8h                          ; 75 07
     mov dl, al                                ; 88 c2
     shr dl, 004h                              ; c0 ea 04
-    jmp short 0358eh                          ; eb 05
+    jmp short 035adh                          ; eb 05
     mov dl, al                                ; 88 c2
     and dl, 00fh                              ; 80 e2 0f
@@ -4430,18 +4466,18 @@
     xor bh, bh                                ; 30 ff
     test dl, dl                               ; 84 d2
-    je short 035a8h                           ; 74 0d
+    je short 035c7h                           ; 74 0d
     cmp dl, 001h                              ; 80 fa 01
-    jbe short 035a5h                          ; 76 05
+    jbe short 035c4h                          ; 76 05
     or bh, 002h                               ; 80 cf 02
-    jmp short 035a8h                          ; eb 03
+    jmp short 035c7h                          ; eb 03
     or bh, 001h                               ; 80 cf 01
     mov word [bp+016h], bx                    ; 89 5e 16
-    jmp near 02faeh                           ; e9 00 fa
+    jmp near 02fc1h                           ; e9 f4 f9
     cmp ah, 001h                              ; 80 fc 01
-    jbe short 035bfh                          ; 76 0c
+    jbe short 035deh                          ; 76 0c
     mov word [bp+016h], si                    ; 89 76 16
     mov ax, strict word 00001h                ; b8 01 00
-    call 02b92h                               ; e8 d6 f5
-    jmp near 03494h                           ; e9 d5 fe
+    call 02ba7h                               ; e8 cc f5
+    jmp near 034b3h                           ; e9 d5 fe
     mov ax, word [bp+016h]                    ; 8b 46 16
     xor ah, ah                                ; 30 e4
@@ -4449,9 +4485,9 @@
     mov word [bp+016h], ax                    ; 89 46 16
     mov ax, strict word 00006h                ; b8 06 00
-    jmp near 02f5ah                           ; e9 8a f9
-    mov bx, 00da6h                            ; bb a6 0d
+    jmp near 02f6dh                           ; e9 7e f9
+    mov bx, 00da2h                            ; bb a2 0d
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
-    call 018cch                               ; e8 f1 e2
+    call 018e1h                               ; e8 e7 e2
     mov ax, word [bp+016h]                    ; 8b 46 16
     shr ax, 008h                              ; c1 e8 08
@@ -4460,8 +4496,8 @@
     push 002c2h                               ; 68 c2 02
     push strict byte 00004h                   ; 6a 04
-    call 0190dh                               ; e8 20 e3
+    call 01922h                               ; e8 16 e3
     add sp, strict byte 00008h                ; 83 c4 08
-    jmp near 02f4ch                           ; e9 59 f9
-get_floppy_dpt_:                             ; 0xf35f3 LB 0x2f
+    jmp near 02f5fh                           ; e9 4d f9
+get_floppy_dpt_:                             ; 0xf3612 LB 0x2f
     push bx                                   ; 53
     push dx                                   ; 52
